## TurnGen: a household chores turn generator
## Copyright (C) 2006 Angelo "Encelo" Theodorou
##

import pygtk
pygtk.require('2.0')
import gtk.glade

class Ranking_Window:
	"""Create the ranking window"""
	def __init__(self, glade_file, db, presence_l, activity_id):
		self.glade_file = glade_file
		self.db = db
		self.presence_l = presence_l
		self.activity_id = activity_id
		
		self.xml = gtk.glade.XML(glade_file, root="table_win")
		
		# Getting widgets
		self.ranking_win = self.xml.get_widget("table_win")
		self.ranking_list = self.xml.get_widget("table_list")

		# Setting initial attributes
		self.ranking_win.set_title(_('Ranking'))
		self.ranking_win.resize(200, 200)

		# Init Methods
		self.setup_ranking_list()
		self.update_ranking_list()
		
		return


	def setup_ranking_list(self):
		"""Setup the ranking list"""
		self.cell = gtk.CellRendererText()

		# Columns
		self.column = gtk.TreeViewColumn(_('User'))
		self.column.pack_start(self.cell, True)
		self.column.add_attribute(self.cell, 'text', 0)
		self.column.set_resizable(True)
		self.column.set_sort_column_id(0)
		self.ranking_list.append_column(self.column)
	
		self.column = gtk.TreeViewColumn(_('Count'))
		self.column.pack_start(self.cell, True)
		self.column.add_attribute(self.cell, 'text', 1)
		self.column.set_resizable(True)
		self.column.set_sort_column_id(1)
		self.ranking_list.append_column(self.column)

		# Model
		self.liststore = gtk.ListStore(str, int)
		self.ranking_list.set_model(self.liststore)


	def update_ranking_list(self):
		"""Update the ranking list"""

		data = self.db.fetch_ranking(self.presence_l, self.activity_id)
		for row in data:
			self.liststore.append([row[0], row[1]])
